; ==============================================================================
;	File list
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver.	Description
;	2020/9/20	t.hara	v1.0	1st release
; ==============================================================================

fl_max_entries	:= 192

; ==============================================================================
;	t@CANZX֘Ȁ
; ==============================================================================
		scope		file_init
file_init::
		; JghCu擾
		ld			c, D1F_CURDRV
		call		bdos
		add			a, 'A'
		ld			[current_drive], a

		; ݂ zhCu؂ւvvgtbN ۑĂ
		di
		ld			a, [h_prompt]
		ld			[save_h_prompt_hook], a
		ld			hl, [h_prompt + 1]
		ld			[save_h_prompt_hook + 1], hl

		; VtbNɍXV
		ld			a, 0xC3			; JP
		ld			[h_prompt], a
		ld			hl, disk_change_prompt
		ld			[h_prompt + 1], hl
		ei
		ret
		endscope

; ==============================================================================
;	t@CANZX֘Ǎn
; ==============================================================================
		scope		file_term
file_term::
		; ̃tbN߂
		di
		ld			hl, [save_h_prompt_hook]
		ld			[h_prompt], hl
		ld			a, [save_h_prompt_hook + 2]
		ld			[h_prompt + 2], a
		ei
		ret
		endscope

; ==============================================================================
;	hCu`FW̃tbNĂ΂郋[`
; ==============================================================================
		scope		disk_change_prompt
disk_change_prompt::
		ld			a, 1
		ld			[called_disk_change_prompt], a
		pop			af			; X^bNꃌx̂Ă
		ret
		endscope

; ==============================================================================
;	t@CANZX֘A BDOSR[
; ==============================================================================
		scope		safe_bdos
safe_bdos::
		; fBXNG[̃|C^̃|C^XV
		push		hl
		ld			hl, [diskve]
		ld			[save_diskve], hl
		ld			hl, [0x0001]
		ld			[save_worm_boot], hl

		ld			hl, ptr_new_diskve
		ld			[diskve], hl
		ld			hl, restore_diskve
		ld			[0x0001], hl
		pop			hl

		ld			[save_sp_for_diskve], sp
		call		bdos

return_address:
		ld			hl, [save_diskve]
		ld			[diskve], hl
		ld			hl, [save_worm_boot]
		ld			[0x0001], hl
		ret

restore_diskve:
		ld			hl, [save_diskve]
		ld			[diskve], hl
		ld			hl, [save_worm_boot]
		ld			[0x0001], hl
		jp			0x0000

physical_error:
		ld			sp, [save_sp_for_diskve]
		ld			a, c
		ld			[error_status], a
		or			a, a
		jr			return_address

ptr_new_diskve:
		dw			physical_error
		endscope

; ==============================================================================
;	JgfBNgύX
;	input)
;		de ..... fBNg(ASCIIZ)
; ==============================================================================
		scope	change_directory
change_directory::
		ld			c, D2F_CHDIR
		call		safe_bdos
		ret
		endscope

; ==============================================================================
;	JghCuύX
;	input)
;		a .... target drive (A:=0, B:=1, ... ,H:=7)
;	output)
;		Zf ... 0: , 1: s
; ==============================================================================
		scope	change_current_drive
change_current_drive::
		ld			e, a
		xor			a, a
		ld			[called_disk_change_prompt], a
		ld			[error_status], a

		; JghCuύX݂ (݂ȂhCuƕύXȂ)
		ld			c, D1F_SELDSK
		call		safe_bdos
		; JghCu^[擾
		ld			c, D1F_CURDRV
		call		bdos
		ld			d, a
		push		de
		; ANZX݂
		ld			bc, (FIB_ATTR_DIRECTORY << 8) | D2F_FFIRST
		ld			de, search_name
		ld			ix, fl_fib
		call		safe_bdos
		; zfBXNhCũfBXN`FWH
		pop			bc
		ld			a, [called_disk_change_prompt]
		or			a, a
		jp			nz, failed
		; n[hG[H
		ld			a, [error_status]
		or			a, a
		jp			nz, failed
		; ɃhCuύXł
		ld			a, b
		add			a, 'A'						; Zf = 0
		ld			[current_drive], a
		ret

failed:
		; w̃hCuzhCuꍇA܂̓n[hG[ꍇAɖ߂
		xor			a, a
		ld			[error_status], a
		ld			a, [current_drive]
		sub			a, 'A'
		ld			e, a
		ld			c, D1F_SELDSK
		call		safe_bdos

		ld			bc, (FIB_ATTR_DIRECTORY << 8) | D2F_FFIRST
		ld			de, search_name
		ld			ix, fl_fib
		call		safe_bdos
		xor			a, a					; Zf = 1
		ret
		endscope

; ==============================================================================
;	fl_update_entries
; ==============================================================================
		scope		fl_update_entries
fl_update_entries::
		call		mmap_change_to_tpa				; set TPA slot on page1 and page2.

		xor			a, a
		ld			[fl_progress], a
		ld			[fl_files], a
		ld			[error_status], a
		ld			hl, end_of_program
		ld			[fl_string_table_bottom], hl

		ld			[fl_fib + 1], a
		ld			hl, fl_fib + 1
		ld			de, fl_fib + 2
		ld			bc, 62
		ldir

		inc			a
		ld			[fl_current_index], a
		dec			a
		dec			a
		ld			[fl_fib], a

		; ŏ̃t@C擾 
		ld			bc, (FIB_ATTR_DIRECTORY << 8) | D2F_FFIRST
		ld			de, search_name
		ld			ix, fl_fib
		call		safe_bdos
		or			a, a
		jr			nz, exit

		; n[hG[mF
		ld			a, [error_status]
		or			a, a
		jr			nz, exit

		ld			hl, fl_fib + FIB_FILENAME
		ld			de, fl_entry_table
		ld			bc, fl_entry_fib_size
		ldir

		ld			de, fl_entry_table
		call		get_mgs_music_title
		ld			a, 0						; CytOۑ
		jr			c, loop
		inc			a
loop:
		; i\
		push		af
		push		de
		ld			a, [fl_progress]
		inc			a
		and			a, 0x0F
		ld			[fl_progress], a
		call		grp_update_master_volume
		pop			de
		pop			af

		; \ȍő吔ɓBH
		ld			[fl_files], a
		cp			a, fl_max_entries
		jr			z, exit

		; 2ڈȍ~̃t@C擾
		push		de
		ld			c, D2F_FNEXT
		ld			ix, fl_fib
		call		safe_bdos
		pop			de
		or			a, a
		jr			nz, exit

		; n[hG[mF
		ld			a, [error_status]
		or			a, a
		jr			nz, exit

		ld			hl, fl_fib + FIB_FILENAME
		ld			bc, fl_entry_fib_size
		push		de
		ldir
		pop			de
		call		get_mgs_music_title

		ld			a, [fl_files]
		jr			c, loop
		inc			a
		jr			loop

exit:
		ld			a, [master_volume]
		call		grp_update_master_volume

		ld			a, [sort_mode]
		or			a, a
		jp			z, fl_sort_normal
		dec			a
		jp			z, fl_sort_title
		jp			fl_sort_filename
		endscope

; ==============================================================================
;	mۂĎw̃t@C̋Ȗ擾
;	input)
;		de ... entry table
;	output)
;		de ... fBNg܂ MGSt@CȂ玟̃Gg̃AhX
;		       ֌WȂt@CȂύX
;		Cy ... 0: L, 1: 
;	break)
;		af, bc
; ==============================================================================
		scope		get_mgs_music_title
get_mgs_music_title::
		push		hl
		push		de
		; fl_entry ̒ ȖAhX(FENT_MGS_TITLE_ADDRESS)  0 NA
		ex			de, hl
		ld			de, FENT_MGS_TITLE_ADDRESS
		add			hl, de
		xor			a, a
		ld			[hl], a
		inc			hl
		ld			[hl], a
		; Agr[g`FbN
		ld			de, (FIB_ATTRIBUTE - FIB_FILENAME) - FENT_MGS_TITLE_ADDRESS - 1
		add			hl, de
		ld			a, [hl]
		and			a, FIB_ATTR_DIRECTORY
		ld			a, 0
		jr			nz, success_exit			; fBNgȂ̂ŉȂ
		; gq`FbN
		ld			de, FIB_FILENAME - FIB_ATTRIBUTE
		add			hl, de
search_dot:
		ld			a, [hl]
		or			a, a
		jr			z, ignore_exit				; gq̂ŉȂ
		inc			hl
		cp			a, '.'
		jr			nz, search_dot
		ld			de, ext_mgs
		call		strcmpi
		jr			z, do_copy					; gq MGS ȂARs[
ignore_exit:
		pop			de
		pop			hl
		scf
		ret
success_exit:
		; FENT_MGS_ENTRY_INDEX XV(A̒lɂ)BfBNgȂ 0, MGSt@CȂCfbNX
		pop			de
		ex			de, hl
		ld			de, FENT_MGS_ENTRY_INDEX
		add			hl, de
		ld			[hl], a
		; ̃Gg̃AhX߂
		ld			de, fl_entry_size - FENT_MGS_ENTRY_INDEX
		add			hl, de
		ex			de, hl
		pop			hl
		or			a, a
		ret
do_copy:
		; read buffer O 0
		xor			a, a
		ld			[error_status], a
		ld			[read_buffer], a
		ld			hl, read_buffer
		ld			de, read_buffer + 1
		ld			bc, 62 + 8
		ldir

		; open the file
		pop			de
		push		de
		ld			c, D2F_OPEN
		ld			a, 1						; Disable write access
		call		safe_bdos
		ld			a, b
		ld			[file_handle], a
		jp			nz, ignore_exit

		; n[hG[mF
		ld			a, [error_status]
		or			a, a
		jr			nz, ignore_exit

		; read the file
		ld			c, D2F_READ
		ld			de, read_buffer
		ld			hl, 62 + 8
		call		safe_bdos

		; n[hG[mF
		ld			a, [error_status]
		or			a, a
		jr			nz, ignore_exit

		; close the file
		ld			c, D2F_CLOSE
		ld			a, [file_handle]
		ld			b, a
		call		safe_bdos

		; n[hG[mF
		ld			a, [error_status]
		or			a, a
		jr			nz, ignore_exit

		; copy music title
		pop			hl
		push		hl
		ld			de, FENT_MGS_TITLE_ADDRESS
		add			hl, de
		ld			de, [fl_string_table_bottom]
		ld			[hl], e
		inc			hl
		ld			[hl], d							; Ȗi[AhXXV

		ld			hl, read_buffer + 8
		call		strlen							; de͔j󂵂ȂBbc ɕ
		inc			bc								; [Rs[̂ +1

		ld			hl, read_buffer + 8
		ldir
		ld			[fl_string_table_bottom], de

		; CfbNX
		ld			a, [fl_current_index]
		inc			a
		ld			[fl_current_index], a
		dec			a
		jr			success_exit
		endscope

; ==============================================================================
;	get_current_file_entry
;	input)
;		a ................... Ώۂ̃t@C̔ԍ (ꗗ\̒̉Ԗڂ)
;	output)
;		Zf .................. 1: t@C(HL), 0: ʏ
;		hl .................. I𒆂̃t@C̃GgAhX
;	break)
;		bcȊOׂ
; ==============================================================================
		scope	get_current_file_entry
get_current_file_entry::
		push	bc
		push	af
		call	mmap_change_to_tpa
		pop		af
		pop		bc
get_current_file_entry_wo_chgslot::
		ld		l, a
		ld		h, 0
		ld		a, [fl_files]
		or		a, a
		ret		z
		; fl_entry_size = 25 = 8 * (2 + 1) + 1
		ld		a, l					; a = file number
		add		hl, hl					; +-- hl = file_number * 8
		add		hl, hl					; |
		add		hl, hl					; |
		ld		e, l					;   +-- de = file_number * 8
		ld		d, h					;   |
		add		hl, hl					;      hl = file_number * 16
		add		hl, de					;      hl = file_number * 16 + file_number * 8
		ld		e, a					;      +-- hl = file_number * 16 + file_number * 8 + file_number = file_number * 25
		ld		d, 0					;      |
		add		hl, de					;      |
		ld		de, fl_entry_table
		add		hl, de					; 0 ɂ͂ȂȂ̂ŁAZf = 0
		ret
		endscope

; ==============================================================================
;	fl_swap_entry
;	input)
;		a .... 1st target entry
;		b .... 2nd target entry
;	comment)
;		swap_cbr_address  HL, DE ̂QWX^ entry ւ锻胋[`
;		̃AhXł
; ==============================================================================
		scope	fl_swap_entry
fl_swap_entry::
		; get 1st target entry address (A)
		push	bc
		call	get_current_file_entry_wo_chgslot

		; get 2nd target entry address (B)
		pop		af
		push	hl
		call	get_current_file_entry_wo_chgslot
		pop		de
		push	de
		push	hl

		; ̃GgXbv邩肷
swap_cbr_address	:= code_address + 1
		call	cbr_compare_normal
		pop		hl
		pop		de
		ret		c

		; swap entry
		ld		b, fl_entry_size
loop:
		ld		a, [de]
		ld		c, [hl]
		ld		[hl], a
		ld		a, c
		ld		[de], a
		inc		hl
		inc		de
		djnz	loop
		ret
		endscope

; ==============================================================================
;	cbr_compare_normal (fBNgGg)
;	input)
;		hl .... 1ڂ̃Gg
;		de .... 2ڂ̃Gg
;	output)
;		CytO ... 0: ւȂ, 1: ւ
;	break)
;		all
; ==============================================================================
		scope	cbr_compare_normal
cbr_compare_normal::
		push	de
		push	hl
		pop		ix
		ld		a, [ix + FENT_MGS_ENTRY_INDEX]
		pop		ix
		ld		b, [ix + FENT_MGS_ENTRY_INDEX]
		sub		a, b
		ret
		endscope

; ==============================================================================
;	cbr_compare_title (Ȗ)
;	input)
;		hl .... 1ڂ̃Gg
;		de .... 2ڂ̃Gg
;	output)
;		CytO ... 0: ւȂ, 1: ւ
;	break)
;		all
; ==============================================================================
		scope	cbr_compare_title
cbr_compare_title::
		push	hl
		push	de
		pop		ix
		ld		a, [ix + FENT_MGS_ENTRY_INDEX]
		ld		l, [ix + FENT_MGS_TITLE_ADDRESS + 0]
		ld		h, [ix + FENT_MGS_TITLE_ADDRESS + 1]
		pop		ix
		ld		b, [ix + FENT_MGS_ENTRY_INDEX]
		ld		e, [ix + FENT_MGS_TITLE_ADDRESS + 0]
		ld		d, [ix + FENT_MGS_TITLE_ADDRESS + 1]
cbr_compare_common::
		inc		b
		dec		b
		scf
		ret		z			; 1ڂfBNgȂΏ (Cy=1)

		or		a, a
		ret		z			; 2ڂfBNgȂΏۊO (Cy=0)

		call	strcmp		; Ȗ̓eŌ𔻒
		ret
		endscope

; ==============================================================================
;	cbr_compare_filename (Ȗ)
;	input)
;		hl .... 1ڂ̃Gg
;		de .... 2ڂ̃Gg
;	output)
;		CytO ... 0: ւȂ, 1: ւ
;	break)
;		all
; ==============================================================================
		scope	cbr_compare_filename
cbr_compare_filename::
		push	hl
		push	de
		pop		ix
		ld		a, [ix + FENT_MGS_ENTRY_INDEX]
		pop		ix
		ld		b, [ix + FENT_MGS_ENTRY_INDEX]
		ex		de, hl
		jp		cbr_compare_common
		endscope

; ==============================================================================
;	fl_buble_sort
;	fl_entry ou\[g餃\[g swap_cbr_address Ŏw肳Ă
;	[`̃AhXɂ
; ==============================================================================
		scope	fl_buble_sort
fl_buble_sort::
		ld		a, [fl_files]
		or		a, a					; t@CΉȂ
		ret		z
		dec		a						; t@C̏ꍇȂ
		ret		z

		ld		bc, 0x0001				; B=ڃGg(0), C=̃Gg(1)
loop1:
		push	bc

loop2:
		push	bc
		ld		a, c
		call	fl_swap_entry
		pop		bc
		inc		c
		ld		a, [fl_files]
		cp		a, c
		jr		nz, loop2

		pop		bc
		; ڃGg֑J
		inc		b
		inc		c
		ld		a, [fl_files]
		cp		a, c
		jr		nz, loop1
		ret
		endscope

; ==============================================================================
;	fl_sort_normal (fBNgGg)
; ==============================================================================
		scope	fl_sort_normal
fl_sort_normal::
		call	mmap_change_to_tpa
		ld		hl, cbr_compare_normal
		ld		[swap_cbr_address], hl
		call	fl_buble_sort
		ret
		endscope

; ==============================================================================
;	fl_sort_title (Ȗ)
; ==============================================================================
		scope	fl_sort_title
fl_sort_title::
		call	mmap_change_to_tpa
		ld		hl, cbr_compare_title
		ld		[swap_cbr_address], hl
		call	fl_buble_sort
		ret
		endscope

; ==============================================================================
;	fl_sort_filename (t@C)
; ==============================================================================
		scope	fl_sort_filename
fl_sort_filename::
		call	mmap_change_to_tpa
		ld		hl, cbr_compare_filename
		ld		[swap_cbr_address], hl
		call	fl_buble_sort
		ret
		endscope

; ==============================================================================
;	Work area
; ==============================================================================
called_disk_change_prompt::
		db			0			; hCu`FWĂ΂ꂽ 1 ɂȂ
save_h_prompt_hook::
		db			0, 0, 0
error_status::
		db			0
save_diskve::
		dw			0
save_worm_boot::
		dw			0
save_sp_for_diskve::
		dw			0
current_drive::
		db			0, 0		; JghCu 'A'`'H': 2byteڂ ASCIIZ̒[
search_name::
		ds		"*.*"
		db		0
ext_mgs::
		ds		"MGS"
		db		0
fl_fib::
		db		0xFF
		ds		" " * 63
read_buffer::
		ds		" " * (62 + 8 + 1)
fl_files::
		db		0				; XgɊi[ĂGg̐
fl_current_index::
		db		1				; fl_entry +24 ߂邽߂̃[NGA
fl_string_table_bottom::
		dw		0				; i[̈̏IAhX
fl_progress::
		db		0

fl_entry_size			:= 25
fl_entry_fib_size		:= 22	; fl_entry ̒ FIBRs[̃TCY
FENT_MGS_TITLE_ADDRESS	:= 22
FENT_MGS_ENTRY_INDEX	:= 24

fl_entry	macro				; 24bytes
		ds		" " * 13		; +0, 13bytes: file name (ASCIIZ)
		db		0				; +13, 1byte: attribute
		dw		0				; +14, 2bytes: last update time
		dw		0				; +16, 2bytes: last update data
		dw		0, 0			; +18, 4bytes: file size
		dw		0				; +22, 2bytes: MGS Music title address
		db		0				; +24, 1byte: Directory entry index, 0: directory, 1..254: MGS file
			endm

fl_entry_table::
		repeat	i,fl_max_entries
		fl_entry
		endr
